#!/bin/bash
inpref=$1
mode=$2
byear=$3
initMTH=$4
ymissval=$5

#---------------- put here the informations about the station data --------------------------------------#
filestndta="Y_input_data.txt"

#################################################################################
#################################################################################
MTH=${initMTH}
if [ ${MTH} = '1' ]; then monchar=Jan; fi
if [ ${MTH} = '2' ]; then monchar=Feb; fi
if [ ${MTH} = '3' ]; then monchar=Mar; fi
if [ ${MTH} = '4' ]; then monchar=Apr; fi
if [ ${MTH} = '5' ]; then monchar=May; fi
if [ ${MTH} = '6' ]; then monchar=Jun; fi
if [ ${MTH} = '7' ]; then monchar=Jul; fi
if [ ${MTH} = '8' ]; then monchar=Aug; fi
if [ ${MTH} = '9' ]; then monchar=Sep; fi
if [ ${MTH} = '10' ]; then monchar=Oct; fi
if [ ${MTH} = '11' ]; then monchar=Nov; fi
if [ ${MTH} = '12' ]; then monchar=Dec; fi
stnfirstdate="01${monchar}${byear}"

####################################################################################################################################################################################
####################################################################################################################################################################################
####################################################################################################################################################################################
#####################################!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! STOP !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    ####################################################################
##################################### UNLESS YOU KNOW WHAT YOU'RE DOING, THERE IS NOTHING TO DO BEYONG THIS LIMIT                                       ############################
####################################################################################################################################################################################
####################################################################################################################################################################################
####################################################################################################################################################################################

############################## GETTING THE STATIONS INFORMATIONS #####################################################################################
readarray -t indata < "${filestndta}"  
nlntot=$(cat "${filestndta}" | wc -l)  	#### TOTAL NUMBER OF ROW IN THE FILE
                                        #### The first 5 contains cpt tags up
echo "-- The input file is                             : " ${filestndta}        
echo "-- Total number of lines in the input file       : " $nlntot                                         

nrecords=$((nlntot-5))   	    	    #### EXACT NUMBER OF records
echo "-- Total exact number of dates in the input file : " $nrecords                                         

# -------------- Get Station Informations --------------#
echo ${indata[2]} | awk '{for (f=1;f<=NF;f++) col[f] = col[f]":"$f} END {for (f=1;f<=NF;f++) print col[f]}' | tr ':' ' ' > bd.txt
    declare -a STATION_NAME=(`cat bd.txt`)
    rm -f bd.txt
    
# -------------- Get Latitude Informations --------------#
echo ${indata[3]} | awk '{for (f=2;f<=NF;f++) col[f] = col[f]":"$f} END {for (f=2;f<=NF;f++) print col[f]}' | tr ':' ' ' > bd.txt
    declare -a STATION_LAT=(`cat bd.txt`)
    rm -f bd.txt
    
# -------------- Get Longitude Informations --------------#
echo ${indata[4]} | awk '{for (f=2;f<=NF;f++) col[f] = col[f]":"$f} END {for (f=2;f<=NF;f++) print col[f]}' | tr ':' ' ' > bd.txt
    declare -a STATION_LON=(`cat bd.txt`)
    rm -f bd.txt

echo "-- Number of Stations in the input file          : " `echo ${STATION_NAME[@]} | wc -w`
echo "-- Number of Latitute in the input file          : " `echo ${STATION_LAT[@]} | wc -w`
echo "-- Number of Longitude in the input file         : " `echo ${STATION_LON[@]} | wc -w`

nstations=`echo ${STATION_NAME[@]} | wc -w`   	    	    #### EXACT NUMBER OF Stations



####### Compute correlation between y eof PC and input time series for each stations  ##############
prefix="correlation_stn_vs_${inpref}" 
filetxt0="${prefix}.csv"
filebin="${prefix}.bin"
rm -f correlation_stn_vs_${inpref}.*

cat > mygrads_calc_correl.gs << EOF
'reinit'
'set display color white'
'c'
'set grads off'

* - - - - - - -- - - - -- - - - -- - - - - - -- - - - - -- - - - -
*/////////////////////////////////////////////////////////////////
*////////   TS MODES OF Y                //////////////////
'open ${inpref}.ctl'
'set undef dfile'
'q ctlinfo'
undeflin=sublin(result,3)
undefval=subwrd(undeflin,2)
'set lat 0'
'set lon $mode'
'set t 1 last'
'q dims'
lintim = sublin(result,5)
NTIM   = subwrd(lintim,13)
'set gxout fwrite'
'set fwrite yts.dat'
'd s2g1d(a)'
'disable fwrite'

****************** create the .ctl to manage the binary file ***************************** 
savectlfile="yts.ctl"
recl=write(savectlfile,'dset ^yts.dat')
recl=write(savectlfile,'undef 'undefval,append)
recl=write(savectlfile,'*options ',append)
recl=write(savectlfile,'title Y score mode $mode',append)
recl=write(savectlfile,'xdef 1 linear 1 1',append)
recl=write(savectlfile,'ydef 1 linear 1 1',append)
recl=write(savectlfile,'zdef 1 linear 1 1',append)
recl=write(savectlfile,'tdef 'NTIM' linear ${stnfirstdate} 1yr',append)
recl=write(savectlfile,'vars 1',append)
recl=write(savectlfile,'yts 0 99 y eof PC',append)
recl=write(savectlfile,'endvars')
ret0=close(savectlfile)
*******************************************************************************************
'close 1'
* - - - - - - -- - - - -- - - - -- - - - - - -- - - - - -- - - - -

* - - - - - - -- - - - -- - - - -- - - - - - -- - - - - -- - - - -
*/////////////////////////////////////////////////////////////////
*////////   SPATIAL MODES OF Y                //////////////////
'open yts.ctl'
'set x 1'
'set y 1'
'set z 1'
'set t 1 last'
'define ayts = yts.1'
'set t 1'

icol=2
nstations=${nstations}
NTOTCOL=nstations+1

while(icol<=NTOTCOL)
    'set time ${stnfirstdate}'
    'import -v latstn -i ${filestndta} -rows 4 -rowe 4 -col 'icol' -u ${ymissval}'
    'import -v lonstn -i ${filestndta} -rows 5 -rowe 5 -col 'icol' -u ${ymissval}'
    'import -v stn -i ${filestndta} -rows 6 -col 'icol' -u ${ymissval} -t0 ${stnfirstdate} -dt 1yr'

    'd latstn'
    latinfo=sublin(result,1)
    stnlat=subwrd(latinfo,4)
*    say '-------------' latinfo
    
    'd lonstn'
    loninfo=sublin(result,1)
    stnlon=subwrd(loninfo,4)
*    say '-------------' loninfo

    'define correl =  tcorr(ayts,stn,t=1, t='NTIM')'
    'd correl'
    res = sublin(result,1)
    valcor = subwrd(res,4)
*    say '-----------  ' res ' 'stnlat ' 'stnlon
*    say '-----------  ' valcor

    istn = icol - 1
    if(istn=1)
     '!rm ${filetxt0}'
      rec=write('${filetxt0}','station'istn' 'stnlat'  'stnlon'  'valcor)
    else
      rec=write('${filetxt0}','station'istn' 'stnlat'  'stnlon'  'valcor,append)
    endif
    
    icol=icol+1
endwhile
'quit'
EOF

grads -blc mygrads_calc_correl.gs
rm -f mygrads_calc_correl.gs

byear=${byear}   #### the first year of the records, the real value is not very relevant cause it's just for computation performance

############################## READ CORRELATION VALUES AT EACH STATIONS  #####################################################################################
readarray -t indata < "${filetxt0}" 
nlntot=$(cat "${filetxt0}" | wc -l)           #### TOTAL NUMBER OF ROW IN THE FILE

if [ $nlntot -ne $nstations ]
    then 
    echo " "
    echo " The number of station in $filestndta is different from the number in $filetxt0 "
    echo " Check the lines above "
    echo " "
    exit
fi
nrec=1   		    	                      #### EXACT NUMBER OF RECORD ie THE TIMES SERIES for each stations
nstations=$nlntot   	    	              #### EXACT NUMBER OF Stations

echo "------------------------ Nlines " $nlntot "----------------------"
nout=`expr $nrec \* $nstations`                 #### FINAL NUMBER OF ROWS of the newfile_ready_to_bin.txt



istn=0

flag="ok"
    
while [ $istn -lt $nstations ]
do
    echo ${indata[$istn]} | awk '{for (f=1;f<=NF;f++) col[f] = col[f]":"$f} END {for (f=1;f<=NF;f++) print col[f]}' | tr ':' ' ' > bd.txt
    declare -a valn0=(`cat bd.txt`)
    rm -f bd.txt
    echo ${valn0[@]}


    declare -a PCTS
    PCTS[0]=$byear   		# year of records
    PCTS[1]=01  			# Month of records   
    PCTS[2]=01  			# day of records   
    PCTS[3]=${STATION_NAME[$istn]}   	# station ID
    PCTS[4]=${STATION_LAT[$istn]}  	# station latitude
    PCTS[5]=${STATION_LON[$istn]}	# station longitude
    
    ad=`echo  ${valn0[3]} | awk '{ print sprintf("%.17f", $1); }'`
    PCTS[6]=${ad}	                # records

#     echo "${STATION_NAME[$istn]} * ${STATION_LAT[$istn]} * ${STATION_LON[$istn]} * ${ad}"
    if [ $flag == "ok" ]
        then
        echo "${PCTS[@]}" > newfile_ready_to_bin.txt
        flag="no"
    else
        echo "${PCTS[@]}" > newfile1.txt
        cat newfile1.txt >> newfile_ready_to_bin.txt
        rm -f newfile1.txt
    fi
    istn=$[$istn+1] 
done


####################################################################################

# -----  rewrite the data again (with format)
echo $nout $(cat "newfile_ready_to_bin.txt" | wc -l) 
nout=$(cat "newfile_ready_to_bin.txt" | wc -l)
nrec=$[$nout/$nstations]

echo $nrec $nout $nstations

# nlntot=$(cat "${filetxt0}" | wc -l)  	#### TOTAL NUMBER OF ROW IN THE FILE
cat > rewrite.f90 << eoffortran

program rewritedata

	integer, parameter :: ir=kkkk
	integer (kind=4) :: year (1:ir), mon(1:ir), day(1:ir)
	character (len=8) :: stn(1:ir)
	real (kind=4) :: lat(1:ir), lon(1:ir)
	real (kind=4) :: var(1:ir)
	integer (kind=4) :: time(1:ir), nlev, nflag

	 open(10,file='newfile_ready_to_bin.txt')
	
	 do i=1,ir
	 read(10,*) year(i), mon(i), day(i), stn(i), lat(i), lon(i), var(i)
	 enddo 
	 
	! putting format to the data

        open(20,file='good_format_newfile_ready_to_bin.txt')
 	
	do i=1,ir
	write(20,200) year(i), mon(i), day(i), stn(i), lat(i), lon(i), var(i)

200     format(i4,2x,i3,2x,i3,4x,a8,6x,f6.2,5x,f6.2,3x,f8.3)  	
	enddo


end program

eoffortran

line1=$(grep ir=kkkk rewrite.f90)
line1a="        integer, parameter :: ir= ${nout} "
sed "s/$line1/$line1a/" rewrite.f90 > rewritedata.f90

gfortran rewritedata.f90
./a.out 

rm -f a.out rewritedata.f90 rewrite.f90

####################################################################################


cat > mybin.c << EOF
	#include <stdio.h>

	struct rpthdr {
	  char id[8];           /* Character station id  */
	  float lat;            /* Latitude of report             */
	  float lon;            /* Longitude of report            */
	  float t;              /* Time in relative grid units    */
	  int  nlev;            /* Number of levels following     */
	  int flag;             /* Level independent var set flag */
	} hdr;

	void main () {

	  FILE *ifile, *ofile;

	  char rec[100];
	  int flag,year,month,day,yrsav,mnsav,dysav,i;
	  float val;

	  ifile = fopen ("good_format_newfile_ready_to_bin.txt","r");
	  ofile = fopen ("output_good_format.bin","wb");

	  if (ifile==NULL || ofile==NULL) {
	    printf ("Error input file\n");
	    return;
	  }

	  flag = 1;

	  while (fgets(rec,79,ifile) != NULL){

	    sscanf (rec,"%i %i %i",&year,&month,&day);
	    sscanf (rec+27," %f %f %f",&hdr.lat,&hdr.lon,&val);
	    
/*      printf ("%d \n",&year);
        printf ("%g \n",&hdr.lat);*/
        
	    for (i=0;i<8;i++) 
	     hdr.id[i] = rec[i+18];
	     
/*       sscanf (rec,"%i %i %i %s %f %f %f",&year,&month,&day, &hdr.id, &hdr.lat,&hdr.lon,&val);
        printf ("%i %i %i %s %f %f %f \n",year,month,day, hdr.id, hdr.lat,hdr.lon,val);*/
	     if(flag) {
	     yrsav = year;
	     mnsav = month;
	     dysav = day;
	     flag = 0;
	     }

	     if (yrsav!=year || mnsav!=month || dysav!=day) {
	     hdr.nlev = 0;
	     fwrite (&hdr,sizeof(struct rpthdr), 1, ofile);
	     }
	     yrsav = year; 
	     mnsav = month;
	     dysav = day;

	     hdr.nlev = 1;
	     hdr.flag = 1;
	     hdr.t = 0.0;

	    fwrite (&hdr,sizeof(struct rpthdr), 1, ofile);
	    fwrite (&val,sizeof(float), 1, ofile);
	  }

	  hdr.nlev = 0;
	  fwrite (&hdr,sizeof(struct rpthdr), 1, ofile);
	}

EOF

##################################################################################################################################################
##################################################################################################################################################
##################################################################################################################################################

gfortran mybin.c
./a.out
rm -f a.out mybin.c
mv output_good_format.bin ${prefix}.bin

#################################################################################
#################################################################################

cat > ${prefix}.ctl << EOF
DSET ${prefix}.bin
DTYPE station
stnmap ${prefix}.map
UNDEF  -999.0 
TITLE station Data
TDEF $nrec LINEAR 01jan${byear} 1dy
VARS 1
a  0 99     XXXXX YYYYY
ENDVARS
EOF

stnmap -i ${prefix}.ctl

######################################################################################################################
rm -f good_format_newfile_ready_to_bin.txt mygrads_plotyy0.gs   newfile_ready_to_bin.txt yts.ctl yts.dat ${prefix}.csv
######################################################################################################################
exit

cat > mygrads_plotyy0.gs << EOF
'reinit'
'set display color white'
'c'
'set grads off'
mode = $mode
seas_frcst = "$seas_frcst"
'open ${prefix}.ctl'
'set lat ${lats} ${latn}'
'set lon ${lonl} ${lonr}'


*******************set axis layout ********************************
ylint = ($latn - $lats)/4
xlint = ($lonr - $lonl)/6

xlint = math_int(math_abs(xlint))
ylint = math_int(math_abs(ylint))

'set xlopts 1 10 0.15'
'set ylopts 1 10 0.15'
*'set xlab %.0f'
*'set ylab %.0f'
'set xlab auto'
'set ylab auto'
*'set grid on'
'set xlint 'xlint
'set ylint 'ylint

************************************************
'set mpdset hires'
'set map 0 1 3'
'set gxout stnmark'
'set cmark 3'
'set digsiz 0.35'
'color_cpt -gxout stnmark -0.5 0.5 0.1 -kind navy->blue->skyblue->white->yellow->orange->darkred'
'd correl'

'set mpdraw off'
'set line 15 0.5'
'draw shp ${shapefile1}'
'set line 15 20'
'draw shp ${shapefile0}'

'set cmark 9'
'set digsiz 0.25'
'color_cpt -gxout stnmark -0.5 0.5 0.1 -kind navy->blue->skyblue->white->yellow->orange->darkred'
'd correl'

'set strsiz 0.15 0.25'
'set string 1 c 10 0'

'set line 1 1 10'
*'drawline Lon 180 Lat 0'

'set line 1 1 1'
'xcbar_cpt -fw 0.1 -fh 0.13 -ft 6 -fs 2 -fo 0 -edge square -line on'

*/////////////////////////////////////////////////////////////////
*////////  VAR.EXP. BY THIS EOF                //////////////////

values=y_eof_val.txt

* SALTAMOS LAS 3 PRIMERAS LINEAS - - - - -

nbrlnhdr=3
start=0
while(start<4)
ret = read(values)
start=start+1
endwhile

maxlin=mode+start-1

* EMPEZAMOS A LEER - - - - - - - -- - - - -

while(start<maxlin)
ret = read(values)
start=start+1
endwhile

lin=sublin(ret,2)

rec = subwrd(lin,3)
fmt = '%-4.2f'
rc1 = math_format(fmt,rec)

***

'draw title YEOF'mode'('rc1'%) / 'seas_frcst

'set mpdraw off'
'set line 15 0.5'
'draw shp 'shpfile1
'set line 1 10'
'draw shp $shpfile0'

***************************************************
'printim y_eof_splt_load_mode_'mode'.png'
'c'
'!convert -trim -density 200 y_eof_splt_load_mode_'mode'.png y_eof_splt_load_mode_'mode'.png'
'!rm yts.ctl yts.dat'
'quit'
EOF

grads -blc mygrads_plotyy0.gs

rm -f good_format_newfile_ready_to_bin.txt mygrads_plotyy0.gs   newfile_ready_to_bin.txt yts.ctl yts.dat
rm -f ${prefix}.csv ${prefix}.ctl ${prefix}.bin ${prefix}.map yts.ctl yts.dat
