#!/bin/bash


prefix=$1
byear=$2
MTH=$3

filetxt0="${prefix}.txt"
filebin="${prefix}.bin"
# prefix="X_CCA_TS"
# filetxt0="${prefix}.txt" 

readarray -t indata < "${filetxt0}"  
nlntot=$(cat "${filetxt0}" | wc -l)  #### TOTAL NUMBER OF ROW IN THE FILE
nclntot=`echo ${indata[3]} | wc -w`  #### EXACT NUMBER OF COLUMN (including modes and time column)

nrec=$[$nlntot-3]   		    #### EXACT NUMBER OF RECORD FOR THE TIMES SERIES
nmodes=$[$nclntot-1]   		    #### EXACT NUMBER OF modes recorded

nout=`expr $nrec \* $nmodes`  # FINAL NUMBER OF ROWS of the newfile_ready_to_bin.txt

iln=3
flag="ok"
year=$byear
while [ $iln -lt $nlntot ]
  do
  valn=${indata[$iln]}
  echo ${valn} | awk '{for (f=1;f<=NF;f++) col[f] = col[f]":"$f} END {for (f=1;f<=NF;f++) print col[f]}' | tr ':' ' ' > bd.txt
  declare -a valn0=(`cat bd.txt`)
  icl=2

    for ((i=1;i<=nmodes;i++)) do
     declare -a PCTS
     iarr=$[$i-1]		# 
     PCTS[0]=$year   		# year of records
     PCTS[1]=$MTH  		# Month of records     
     PCTS[2]="MOD"$i   		# station ID
     PCTS[3]=0.0  		# station latitude
     PCTS[4]=$i.0			# station longitude
	#nlt=`bc <<< "(($latn - $lats)/$dta_rsl)+1" `
#echo ${valn0[$i]}
#ad=`expr ${valn0[$i]} \* 100`
#ad=`bc <<< "${valn0[$i]}*100" `  # here u r mul by 100 to increse the magnitude of the mode
ad=`echo  ${valn0[$i]} | awk '{ print sprintf("%.17f", $1); }'`
echo "$ad  ======= ${valn0[$i]} "
#exit
#     PCTS[5]=$ad   #${valn0[$i]}		# scores off the mode
#     PCTS[5]=${valn0[$i]}		# scores off the mode
#	PCTS[5]=${valn0[$i]}
	PCTS[5]=${ad}
     if [ $flag == "ok" ]
      then
      echo "${PCTS[@]}" > newfile_ready_to_bin.txt
     else
      echo "${PCTS[@]}" > newfile1.txt
      cat newfile1.txt >> newfile_ready_to_bin.txt
      rm -f newfile1.txt
     fi
#       echo "${PCTS[@]}"
     flag="no"
    done
    rm -f bd.txt
  iln=$[$iln+1]
  year=$[$year+1]
done



####################################################################################

# -----  rewrite the data again (with format)

cat > rewrite.f90 << termina

program rewritedata

	integer, parameter :: ir=kkkk
	integer (kind=4) :: year (1:ir), mon(1:ir)
	character (len=4) :: stn(1:ir)
	real (kind=4) :: lat(1:ir), lon(1:ir)
	real (kind=4) :: var(1:ir)
	integer (kind=4) :: time(1:ir), nlev, nflag


	 open(10,file='newfile_ready_to_bin.txt')
	
	 do i=1,ir
	 read(10,*) year(i), mon(i), stn(i), lat(i), lon(i), var(i)
	 enddo 
	 

	! putting format to the data

        open(20,file='output_cpt.txt')
 	
	do i=1,ir
	write(20,200) year(i), mon(i), stn(i), lat(i), lon(i), var(i)

200     format(i4,2x,i3,4x,a4,6x,f6.2,5x,f6.2,3x,f8.3)  	
	enddo


end program

termina

line1=$(grep ir=kkkk rewrite.f90)
line1a="        integer, parameter :: ir= ${nout} "
sed "s/$line1/$line1a/" rewrite.f90 > rewritedata.f90

gfortran rewritedata.f90

./a.out 
rm -f a.out rewritedata.f90 rewrite.f90
 
####################################################################################

## C+ part ...tras formatear data... se convierte a binario...
## lon 1= modo 1 | lon 2 = modo 2 ...etc etc
## todos tienen lat=0

cat > mybin.c << EOF
	#include <stdio.h>

	struct rpthdr {
	  char id[8];           /* Character station id  */
	  float lat;            /* Latitude of report             */
	  float lon;            /* Longitude of report            */
	  float t;              /* Time in relative grid units    */
	  int  nlev;            /* Number of levels following     */
	  int flag;             /* Level independent var set flag */
	} hdr;

	void main () {

	  FILE *ifile, *ofile;

	  char rec[80];
	  int flag,year,month,yrsav,mnsav,i;
	  float val;

	  ifile = fopen ("output_cpt.txt","r");
	  ofile = fopen ("output_cpt.bin","wb");

	  if (ifile==NULL || ofile==NULL) {
	    printf ("Error input file\n");
	    return;
	  }

	  flag = 1;

	  while (fgets(rec,79,ifile) != NULL){

	    sscanf (rec,"%i %i",&year,&month);
	    sscanf (rec+23," %g %g %g",&hdr.lat,&hdr.lon,&val);

	    for (i=0;i<8;i++) 
	     hdr.id[i] = rec[i+14];

	     if(flag) {
	     yrsav = year;
	     mnsav = month;
	     flag = 0;
	     }

	     if (yrsav!=year || mnsav!=month) {
	     hdr.nlev = 0;
	     fwrite (&hdr,sizeof(struct rpthdr), 1, ofile);
	     }
	     yrsav = year; 
	     mnsav = month;

	     hdr.nlev = 1;
	     hdr.flag = 1;
	     hdr.t = 0.0;

	    fwrite (&hdr,sizeof(struct rpthdr), 1, ofile);
	    fwrite (&val,sizeof(float), 1, ofile);
	  }

	  hdr.nlev = 0;
	  fwrite (&hdr,sizeof(struct rpthdr), 1, ofile);
	}

EOF

##################################################################################################################################################
##################################################################################################################################################
##################################################################################################################################################

gfortran mybin.c
./a.out
rm -f a.out mybin.c

#################################################################################
#################################################################################

if [ ${MTH} = '1' ]
then 
monchar=Jan
fi

if [ ${MTH} = '2' ]
then 
monchar=Feb
fi

if [ ${MTH} = '3' ]
then 
monchar=Mar
fi

if [ ${MTH} = '4' ]
then 
monchar=Apr
fi

if [ ${MTH} = '5' ]
then 
monchar=May
fi

if [ ${MTH} = '6' ]
then 
monchar=Jun
fi

if [ ${MTH} = '7' ]
then 
monchar=Jul
fi

if [ ${MTH} = '8' ]
then 
monchar=Aug
fi

if [ ${MTH} = '9' ]
then 
monchar=Sep
fi

if [ ${MTH} = '10' ]
then 
monchar=Oct
fi

if [ ${MTH} = '11' ]
then 
monchar=Nov
fi

if [ ${MTH} = '12' ]
then 
monchar=Dec
fi



#################################################################################
#################################################################################

mv output_cpt.bin ${prefix}.bin

cat > ${prefix}.ctl << EOF
DSET ${prefix}.bin
DTYPE station
stnmap ${prefix}.map
UNDEF  -999.0 
TITLE station Data
TDEF $nrec LINEAR 1${monchar}${byear} 1yr
VARS 1
a  0 99     XXXXX YYYYY
	ENDVARS
EOF

stnmap -i ${prefix}.ctl

#rm newfile_ready_to_bin.txt output_cpt.txt
