#!/bin/bash 
y_area="CAmer"

figoutputdir0="${y_area}_Fig/Exp2/STN_PRECIP"
##### Predictand period to forecast #####
seas_fcst="MAM"; 


##### predictor Initial Condition JAS/JUN #####
ICPRED="Febic_3-5"
with_sync="yes"

##### Periode of study startyear and endyear####
hdcstbyear=1983
hdcsteyear=2020

###### Setting Climatology period 30ans #####
yrclim1=1991
yrclim2=2020

##### Missing data of x and y respectively ######
xmissval=-999.0
ymissval=-9999.0

#### Number of EOF ####
maxeof=5
crxwdlgth=3

###################  Input Predictand rain Experiment Domain  ###########################
Lats_Y=17.0   		#  Southern Latitude of the Predictand Y, Example:  -20
Latn_Y=27.0   		#  Northern Latitude of the Predictand Y, Example:  -2.
Lonw_Y=-83.0          #  Western Longitude of the Predictand Y, Example:  -86.0
Lone_Y=-64.0           #  Eastern Longitude of the Predictand Y, Example:  -66.

yindir="../Script_gen_Obs_CPT_data/CPT_PREDICTANT"
yfile="CPT_FMT_CAmer_cpcuni_MAM_1983-2020.txt"
nstations=39        #### Number of Stations #####

shpfile0="/cpc/home/ebekele/cpt/COUNTRY_MASK_SHAPEFILE/Continents/SHP_FILE/WMO_basemap.shp"
shpfile1="/cpc/home/ebekele/cpt/COUNTRY_MASK_SHAPEFILE/Continents/SHP_FILE/WMO_basemap.shp"


###################  Input Predictor file SST ###########################

#/cpc/home/ebekele/cpt/Script_Convert_NMME_bin2cpt/NMME_DATA/nmme_sst_hcst_Febic_3-5_1983-2020.txt
#xindir="../Script_Convert_NMME_bin2cpt/NMME_DATA"
xindir="/cpc/home/ebekele/cpt/Script_Convert_NMME_bin2cpt/NMME_DATA"

#SSTAREA=("GBL" "GBL_TROP" "TROP_ATL" "TROP_NTH_ATL" "TROP_STH_ATL" "GG" "TROP_PAC" "TROP_IND")
SSTAREA=("GBL_TROP")
MDLSVECT=("nmme")
#MDLSVECT=("cfsv2" "cmc1" "cmc2" "gfdl_flor" "gfdl" "nasa" "ncar_ccsm4" "nmme")

skillfilename="skill_area_avg_y_precip_${seas_fcst}_x_NMME_SST_${ICPRED}_${hdcstbyear}-${hdcsteyear}.txt" #
rm -f skill_area_avg.csv


file_predictand="${yindir}/${yfile}"

for mdl_title in ${MDLSVECT[@]} 
    do 
    xfile="${mdl_title}_sst_hcst_${ICPRED}_1983-2020.txt"

    file_predictor="${xindir}/${xfile}"

    ls -lrt $file_predictand
    ls -lrt $file_predictor
#exit
    for sst_area in ${SSTAREA[@]}
        do

    	if [ $sst_area == "GBL" ]; then Latn_X=40; Lats_X=-60; Lonw_X=0; Lone_X=360; fi
    	if [ $sst_area == "GBL_TROP" ]; then Latn_X=30; Lats_X=-30; Lonw_X=0; Lone_X=360; fi
    	if [ $sst_area == "TROP_ATL" ]; then Latn_X=30; Lats_X=-30; Lonw_X=-45; Lone_X=15; fi
    	if [ $sst_area == "TROP_NTH_ATL" ]; then Latn_X=30; Lats_X=-10; Lonw_X=-45; Lone_X=15; fi
    	if [ $sst_area == "TROP_STH_ATL" ]; then Latn_X=15; Lats_X=-30; Lonw_X=-45; Lone_X=15; fi
    	if [ $sst_area == "GG" ]; then Latn_X=5; Lats_X=-5; Lonw_X=-10; Lone_X=10; fi
    	if [ $sst_area == "TROP_PAC" ]; then Latn_X=15; Lats_X=-15; Lonw_X=120; Lone_X=-70; fi
    	if [ $sst_area == "TROP_IND" ]; then Latn_X=30; Lats_X=-30; Lonw_X=30; Lone_X=120; fi

    	figoutputdir="${figoutputdir0}/NMME/${ICPRED}/${mdl_title}/Exp_X_sst_${ICPRED}-${mdl_title}_${sst_area}_vs_Y_precip_${seas_fcst}_${hdcstbyear}-${hdcsteyear}"

    	mkdir -p ${figoutputdir}

    	rm -f *.png
    	bash script_cpt_exp_run_plot_for_stn_vs_NMME.sh $seas_fcst ${Latn_Y} ${Lats_Y} ${Lonw_Y} ${Lone_Y} ${file_predictand} ${shpfile0} ${shpfile1} $nstations $ymissval ${ICPRED} ${sst_area} ${Latn_X} ${Lats_X} ${Lonw_X} ${Lone_X} ${mdl_title} ${file_predictor} $xmissval ${maxeof} ${crxwdlgth} ${hdcstbyear} ${hdcsteyear} ${with_sync} ${yrclim1} ${yrclim2} rain


    	mv -f *.png ${figoutputdir}/.

	rm -f *.ctl *.dat *.txt *.map *.bin Y_input_data.*

    done

done 
mv skill_area_avg.csv $figoutputdir0/$skillfilename
