#!/bin/sh 
maxeof=6
WKDIR=$(pwd)

byear=1951
eyear=2017
midmth=5
rm -f skill_area_avg.csv

with_sync="yes"

###################  Input Predictand Experiment Domain  ###########################
Lats_Y=0    		#  Southern Latitude of the Predictand Y, Example:  -20
Latn_Y=8    		#  Northern Latitude of the Predictand Y, Example:  -2.
Lonl_Y=100 		#  Western Longitude of the Predictand Y, Example:  -86.0
Lonr_Y=120		#  Eastern Longitude of the Predictand Y, Example:  -66.
 
sst_area="GBL_TROP"

	if [ $sst_area = "GBL_TROP" ] 
	  then
	  Lats_X=-30
	  Latn_X=30
	  Lonl_X=0
	  Lonr_X=360
	fi

	if [ $sst_area = "TROP_ATL" ] 
	  then
	  Lats_X=-30
	  Latn_X=30
	  Lonl_X=-45
	  Lonr_X=15
	fi

	if [ $sst_area = "TROP_NTH_ATL" ] 
	  then
	  Lats_X=-10
	  Latn_X=30
	  Lonl_X=-45
	  Lonr_X=15
	fi

	if [ $sst_area = "TROP_STH_ATL" ] 
	  then
	  Lats_X=-30
	  Latn_X=15
	  Lonl_X=-45
	  Lonr_X=15
	fi

	if [ $sst_area = "GG" ] 
	  then
	  Lats_X=-5
	  Latn_X=5
	  Lonl_X=-10
	  Lonr_X=10
	fi



file_predictor=${WKDIR}/"ersstv4.djf.tsv"
file_predictand=${WKDIR}/"djf_malaysia_stn.tsv"
# make input file for the cpt

cat > cpt_input_without_sync.txt << EOF
611
1
${file_predictor}
${Latn_X}
${Lats_X}
${Lonl_X}
${Lonr_X}
1
${maxeof}
2
${file_predictand}
${Latn_Y}
${Lats_Y}
${Lonl_Y}
${Lonr_Y}
1
${maxeof}
1
${maxeof}
311
131
3
111
302
${WKDIR}/x_eof_sptl_load
411
${WKDIR}/x_cca_sptl_load
0
131
2
413
1
${WKDIR}/pc_skill_map
413
10
${WKDIR}/rocbn_skill_map
413
11
${WKDIR}/rocan_skill_map
111
312
${WKDIR}/y_eof_sptl_load
421
${WKDIR}/y_cca_sptl_load
301
${WKDIR}/x_eof_val
303
${WKDIR}/x_eof_ts
311
${WKDIR}/y_eof_val
313
${WKDIR}/y_eof_ts
401
${WKDIR}/x_y_cancor
412
${WKDIR}/x_cca_ts
422
${WKDIR}/y_cca_ts
0
0
EOF


cat > cpt_input_with_sync.txt << EOF
611
1
${file_predictor}
${Latn_X}
${Lats_X}
${Lonl_X}
${Lonr_X}
1
${maxeof}
2
${file_predictand}
${Latn_Y}
${Lats_Y}
${Lonl_Y}
${Lonr_Y}
1
${maxeof}
1
${maxeof}
545
311
131
3
111
302
${WKDIR}/x_eof_sptl_load
411
${WKDIR}/x_cca_sptl_load
0
131
2
413
1
${WKDIR}/pc_skill_map
413
10
${WKDIR}/rocbn_skill_map
413
11
${WKDIR}/rocan_skill_map
111
312
${WKDIR}/y_eof_sptl_load
421
${WKDIR}/y_cca_sptl_load
301
${WKDIR}/x_eof_val
303
${WKDIR}/x_eof_ts
311
${WKDIR}/y_eof_val
313
${WKDIR}/y_eof_ts
401
${WKDIR}/x_y_cancor
412
${WKDIR}/x_cca_ts
422
${WKDIR}/y_cca_ts
0
0
EOF


if [ $with_sync = "yes" ] 
then		
  mv cpt_input_with_sync.txt cpt_input.txt
  rm -f cpt_input_without_sync.txt
else
  mv cpt_input_without_sync.txt cpt_input.txt
  rm -f cpt_input_with_sync.txt
fi

cd /home/phkt/CPT/15.5.5
# cd ../CPT/15.5.10 
bin/CPT.x < ${WKDIR}/cpt_input.txt

cd ${WKDIR}
rm -f cpt_input.txt

# exit
##############################################################
# convert cpt output txt datas above (x/y_eof/cca/ts) to grads binary format
./cptdata_ts_convert_to_binary.sh x_eof_ts $byear ${midmth}
./cptdata_ts_convert_to_binary.sh y_eof_ts $byear ${midmth}
./cptdata_ts_convert_to_binary.sh x_cca_ts $byear ${midmth}
./cptdata_ts_convert_to_binary.sh y_cca_ts $byear ${midmth}


##############################################################
# convert cpt output txt datas above (pc, rocbn, rocan, y_eof/cca/) to grads binary format
./convert_stn_to_binary.sh pc_skill_map
./convert_stn_to_binary.sh rocbn_skill_map
./convert_stn_to_binary.sh rocan_skill_map
./convert_stn_to_binary.sh y_eof_sptl_load
./convert_stn_to_binary.sh y_cca_sptl_load



#     if [ $mdls = "ersst4" ]
#       then
#       mdl_title="ERSSTv4"  
#     else
#       mdl_title=$mdls
#     fi
# 
# # exit

mdl_title="ersstv4"
shpfile0="/home/phkt/CPC_WORK/MYS_adm/MYS_adm0.shp"
shpfile1="/home/phkt/CPC_WORK/MYS_adm/MYS_adm1.shp"
seas_frcst="DJF"
ICPRED="DJF" 
# sst_area="GBL"



      ./Run_PLOT_STN_PC_SKILL_MAP.sh $mdl_title $shpfile0 $shpfile1 $seas_frcst $ICPRED $sst_area ${Lats_Y} ${Latn_Y} ${Lonl_Y} ${Lonr_Y} 30
#       mv PC_skill_map.png CPT_PC_SKILL_MAP_X-${mdls}-$sst_area-${seas_pred}_Y-arc2-${clim_area}-${seas_frcst}.png
# #       cp *.png ${figoutputdir}/.

      ./Run_PLOT_STN_ROC_AN_MAP.sh $mdl_title $shpfile0 $shpfile1 $seas_frcst $ICPRED $sst_area ${Lats_Y} ${Latn_Y} ${Lonl_Y} ${Lonr_Y}
#       mv ROCAN_skill_map.png CPT_ROC-AN_SKILL_MAP_X-${mdls}-$sst_area-${seas_pred}_Y-arc2-${clim_area}-${seas_frcst}.png
# 

      ./Run_PLOT_STN_ROC_BN_MAP.sh $mdl_title $shpfile0 $shpfile1 $seas_frcst $ICPRED $sst_area ${Lats_Y} ${Latn_Y} ${Lonl_Y} ${Lonr_Y}
#       mv ROCBN_skill_map.png CPT_ROC-BN_SKILL_MAP_X-${mdls}-$sst_area-${seas_pred}_Y-arc2-${clim_area}-${seas_frcst}.png
# 
# 
# 
# 
	for mode in 1 2 3
	 do 
	 ./Run_PLOT_X_EOF_SPLT_LOAD_MAP.sh $mode $mdl_title $ICPRED $sst_area
# 	  mv x_eof_splt_load_mode_${mode}.png  CPT_X_EOF${mode}_SPLT_LOAD-${mdls}-$sst_area-${seas_pred}.png
# 
	 ./Run_PLOT_X_EOF_time_serie.sh $mode $mdl_title $ICPRED $sst_area
# 	  mv x_eof_ts_mode_${mode}.png  CPT_X_EOF${mode}_TS-${mdls}-$sst_area-${seas_pred}.png
# 

 	 ./Run_PLOT_STN_Y_EOF_SPLT_LOAD_MAP.sh $mode $shpfile0 $shpfile1 $seas_frcst ${Lats_Y} ${Latn_Y} ${Lonl_Y} ${Lonr_Y}
# 	  mv y_eof_splt_load_mode_${mode}.png  CPT_Y_EOF${mode}_SPLT_LOAD-arc2-${clim_area}-$seas_frcst.png

	 ./Run_PLOT_STN_Y_EOF_time_serie.sh $mode $seas_frcst
# 	  mv y_eof_ts_mode_${mode}.png  CPT_Y_EOF${mode}_TS-arc2-${clim_area}-$seas_frcst.png
# 
# 
# 
# 
	 ./Run_PLOT_X_CCA_SPLT_LOAD_MAP.sh $mode $mdl_title $ICPRED $sst_area
# 	  mv x_cca_splt_load_mode_${mode}.png  CPT_X_CCA${mode}_SPLT_LOAD-${mdls}-$sst_area-${seas_pred}.png
# 
	 ./Run_PLOT_STN_Y_CCA_SPLT_LOAD_MAP.sh $mode $shpfile0 $shpfile1 $seas_frcst ${Lats_Y} ${Latn_Y} ${Lonl_Y} ${Lonr_Y}
# 	  mv y_cca_splt_load_mode_${mode}.png  CPT_Y_CCA${mode}_SPLT_LOAD-arc2-${clim_area}-$seas_frcst.png
# 
	 ./Run_PLOT_X_Y_CCA_time_serie.sh  $mode  
# 	  mv x_y_cca_ts_mode_${mode}.png  CPT_CCA_${mode}_TS-arc2-X-${mdls}-$sst_area-${seas_pred}_Y-arc2-${clim_area}-${seas_frcst}.png  
# exit
	done
# 
	rm -f *.ctl *.dat *.txt *.map *.bin
# 	cp -f *.png ${figoutputdir}/.
# # 	cp CPT_PC_SKILL_MAP_X-${mdls}-$sst_area-${seas_pred}_Y-arc2-${clim_area}-${seas_frcst}.png ${figoutputdir}/.
# # exit
